package com.yunfeiyun.agmp.common.framework.web.service;

import com.yunfeiyun.agmp.common.core.domain.model.IBaseUser;
import com.yunfeiyun.agmp.common.core.domain.model.IBaseUserBind;
import com.yunfeiyun.agmp.common.web.system.domain.SysRes;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

/**
 * 用户 业务层
 * 
 * @author 杨晓辉
 */
public interface ISysUserService
{
    /**
     * 根据条件分页查询用户列表
     * 
     * @param user 用户信息
     * @return 用户信息集合信息
     */
    public List<IBaseUser> selectUserList(IBaseUser user);

    public List<IBaseUser> selectUserListOfAuth(IBaseUser sysUser);

    /**
     * 根据条件分页查询已分配用户角色列表
     * 
     * @param user 用户信息
     * @return 用户信息集合信息
     */
    public List<IBaseUser> selectAllocatedList(IBaseUser user);

    /**
     * 根据条件分页查询未分配用户角色列表
     * 
     * @param user 用户信息
     * @return 用户信息集合信息
     */
    public List<IBaseUser> selectUnallocatedList(IBaseUser user);

    /**
     * 通过用户名查询用户
     * 
     * @param userName 用户名
     * @return 用户对象信息
     */
    public IBaseUser selectUserByUserName(String userName);

    /**
     * 通过用户ID查询用户
     * 
     * @param userId 用户ID
     * @return 用户对象信息
     */
    public IBaseUser selectUserById(String userId);

    /**
     * 根据用户ID查询用户所属角色组
     * 
     * @param userName 用户名
     * @return 结果
     */
    public String selectUserRoleGroup(String userName);

    /**
     * 根据用户ID查询用户所属岗位组
     * 
     * @param userName 用户名
     * @return 结果
     */
    public String selectUserPostGroup(String userName);

    /**
     * 校验用户名称是否唯一
     * 
     * @param user 用户信息
     * @return 结果
     */
    public boolean checkUserNameUnique(IBaseUser user);

    /**
     * 校验手机号码是否唯一
     *
     * @param user 用户信息
     * @return 结果
     */
    public boolean checkPhoneUnique(IBaseUser user);

    /**
     * 校验email是否唯一
     *
     * @param user 用户信息
     * @return 结果
     */
    public boolean checkEmailUnique(IBaseUser user);

    /**
     * 校验用户是否允许操作
     * 
     * @param user 用户信息
     */
    public void checkUserAllowed(IBaseUser user);

    /**
     * 校验用户是否有数据权限
     * 
     * @param userId 用户id
     */
    public void checkUserDataScope(String userId);

    /**
     * 新增用户信息
     * 
     * @param user 用户信息
     * @return 结果
     */
    public int insertUser(IBaseUser user);

    /**
     * 注册用户信息
     * 
     * @param user 用户信息
     * @return 结果
     */
    public boolean registerUser(IBaseUser user);

    /**
     * 修改用户信息
     * 
     * @param user 用户信息
     * @return 结果
     */
    public int updateUser(IBaseUser user);

    /**
     * 用户授权角色
     * 
     * @param userId 用户ID
     * @param roleIds 角色组
     */
    public void insertUserAuth(String userId, String[] roleIds);

    /**
     * 修改用户状态
     * 
     * @param user 用户信息
     * @return 结果
     */
    public int updateUserStatus(IBaseUser user);

    /**
     * 修改用户基本信息
     * 
     * @param user 用户信息
     * @return 结果
     */
    public int updateUserProfile(IBaseUser user);

    /**
     * 修改用户头像
     * 
     * @param userId 用户Id
     * @param avatar 头像地址
     * @return 结果
     */
    public SysRes updateUserAvatar(String userId, MultipartFile file);

    /**
     * 重置用户密码
     * 
     * @param user 用户信息
     * @return 结果
     */
    public int resetPwd(IBaseUser user);

    /**
     * 重置用户密码
     * 
     * @param userName 用户名
     * @param password 密码
     * @return 结果
     */
    public int resetUserPwd(String userName, String password);

    /**
     * 通过用户ID删除用户
     * 
     * @param userId 用户ID
     * @return 结果
     */
    public int deleteUserById(String userId);

    /**
     * 批量删除用户信息
     * 
     * @param userIds 需要删除的用户ID
     * @return 结果
     */
    public int deleteUserByIds(String[] userIds);

    /**
     * 导入用户数据
     * 
     * @param userList 用户数据列表
     * @param isUpdateSupport 是否更新支持，如果已存在，则进行更新数据
     * @param operName 操作用户
     * @return 结果
     */
    public String importUser(List<IBaseUser> userList, Boolean isUpdateSupport, String operName);
    /**
     * 查询用户绑定
     *
     * @param userId 用户Id
     * @param sysId 系统Id
     * @return 结果
     */
    public List<IBaseUserBind> selectPtsUserBind(String userId , String sysId);

    /**
     * 查询用户绑定
     *
     * @param userId 用户Id
     * @param sysId 系统Id
     * @param orgEnabled 组织架构是否
     * @return 结果
     */

    public List<IBaseUserBind> selectPtsUserBind(String userId , String sysId, boolean orgEnabled);
    /**
     * 查询用户绑定数目
     *
     * @param userId 用户Id
     * @param sysId 系统Id
     * @return 结果
     */
    public int hasPtsSysUserId(String userId, String sysId,String userbindSysuser);
    /**
     * 新增用户绑定
     *
     * @param userId 用户Id
     * @param sysId 系统Id
     * @return 结果
     */
    public int insertPtsUserBind(String userId , String sysId,String userbindSysuser);
    /**
     * 删除用户绑定
     *
     * @param userList 用户Id
     * @return 结果
     */
    public int deletePtsUserBind( List<IBaseUserBind> userList);
}
